net.sourceforge.pmd

## Class Report

- java.lang.Object
- - net.sourceforge.pmd.Report

    public class Report
    extends Object

### Nested Class Summary

Nested Classes
`static class` `Report.ProcessingError`
`static class` `Report.ReadableDuration`
`static class` `Report.RuleConfigurationError`
`static class` `Report.SuppressedViolation`

### Constructor Summary

Constructors
Constructor and Description
`Report()`

### Method Summary

Methods
`void` `addConfigError(Report.RuleConfigurationError error)`
`void` `addError(Report.ProcessingError error)`
`void` `addListener(ReportListener listener)`
`void` `addMetric(Metric metric)`
`void` `addRuleViolation(RuleViolation violation)`
`void` `addSynchronizedListeners(List<SynchronizedReportListener> synchronizedListeners)`
`Iterator<Report.RuleConfigurationError>` `configErrors()`
`static Report` `createReport(RuleContext ctx, String fileName)`
`void` `end()`
`Iterator<Report.ProcessingError>` `errors()`
`Map<String,Integer>` `getCountSummary()`
`long` `getElapsedTimeInMillis()`
`Map<String,Integer>` `getSummary()`
`List<Report.SuppressedViolation>` `getSuppressedRuleViolations()`
`List<SynchronizedReportListener>` `getSynchronizedListeners()`
`ReportTree` `getViolationTree()`
`boolean` `hasConfigErrors()`
`boolean` `hasErrors()`
`boolean` `hasMetrics()`
`boolean` `isEmpty()`
`Iterator<RuleViolation>` `iterator()`
`void` `merge(Report r)`
`Iterator<Metric>` `metrics()`
`int` `size()`
`void` `start()`
`void` `suppress(Map<Integer,String> lines)`
`boolean` `treeIsEmpty()`
`Iterator<RuleViolation>` `treeIterator()`
`int` `treeSize()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### Report

    public Report()

### Method Detail

#### createReport

    public static Report createReport(RuleContext ctx,
                      String fileName)

#### suppress

    public void suppress(Map<Integer,String> lines)

#### getCountSummary

    public Map<String,Integer> getCountSummary()

#### getViolationTree

    public ReportTree getViolationTree()

#### getSummary

    public Map<String,Integer> getSummary()

Returns:
  a Map summarizing the Report: String (rule name) ->Integer (count of violations)

#### addListener

    public void addListener(ReportListener listener)

#### getSuppressedRuleViolations

    public List<Report.SuppressedViolation> getSuppressedRuleViolations()

#### addRuleViolation

    public void addRuleViolation(RuleViolation violation)

#### addMetric

    public void addMetric(Metric metric)

#### addConfigError

    public void addConfigError(Report.RuleConfigurationError error)

#### addError

    public void addError(Report.ProcessingError error)

#### merge

    public void merge(Report r)

#### hasMetrics

    public boolean hasMetrics()

#### metrics

    public Iterator<Metric> metrics()

#### isEmpty

    public boolean isEmpty()

#### hasErrors

    public boolean hasErrors()

#### hasConfigErrors

    public boolean hasConfigErrors()

#### treeIsEmpty

    public boolean treeIsEmpty()

#### treeIterator

    public Iterator<RuleViolation> treeIterator()

#### iterator

    public Iterator<RuleViolation> iterator()

#### errors

    public Iterator<Report.ProcessingError> errors()

#### configErrors

    public Iterator<Report.RuleConfigurationError> configErrors()

#### treeSize

    public int treeSize()

#### size

    public int size()

#### start

    public void start()

#### end

    public void end()

#### getElapsedTimeInMillis

    public long getElapsedTimeInMillis()

#### getSynchronizedListeners

    public List<SynchronizedReportListener> getSynchronizedListeners()

#### addSynchronizedListeners

    public void addSynchronizedListeners(List<SynchronizedReportListener> synchronizedListeners)